#!/bin/sh
### BEGIN INIT INFO
# Provides:          isso
# Required-Start:    $network $local_fs $remote_fs
# Required-Stop:     $network $local_fs $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: lightweight Disqus alternative
# Description:       lightweight Disqus alternative
### END INIT INFO

# Author: Jan Graichen <jg@altimos.de>

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
# Short description
DESC=isso
# Service name
NAME=isso
# System user
USER=isso
GROUP=nogroup
PIDFILE=/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

DAEMON=/usr/bin/gunicorn       # Introduce the server's location here
DAEMON_ARGS="--log-file /var/log/isso.log --user $USER --group $GROUP --preload isso.dispatch"

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
    # Exit if the START_DAEMON is not set to "yes" in /etc/default/isso
    if [ "$START_DAEMON" != "yes" ]; then
        echo "Not starting Isso, see /etc/default/isso"
        exit 0
    fi

    # Exit if the configuration directory is missing.
    if [ ! -d "$ISSO_CONF_FILES_DIR" ]; then
         echo "The directory $ISSO_CONF_FILES_DIR is missing - exiting."
         exit 0
    fi

    # Exit if there are no configuation files
    [ -z "$(find "$ISSO_CONF_FILES_DIR" -maxdepth 1 -name '*.cfg')" ] && \
        echo "No configuration files found in $ISSO_CONF_FILES_DIR - exiting." && exit 0

    export ISSO_SETTINGS="$ISSO_CONF_FILES_DIR"

    # Exit if gunicorn is missing
    if [ ! -x "$DAEMON" ]; then
        echo "Please install the gunicorn server: sudo apt-get install gunicorn"
        exit 1
    fi

    # Add IP address / TCP port for Gunicorn to listen on
    if [ -n "$ISSO_ADDRESS_PORT" ]; then
        DAEMON_ARGS="$DAEMON_ARGS --bind $ISSO_ADDRESS_PORT"
    fi

    # Return
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started
    start-stop-daemon --start --quiet \
        --pidfile $PIDFILE \
        --exec $DAEMON \
        --test > /dev/null \
        || return 1
    start-stop-daemon --start --quiet \
        --make-pidfile \
        --pidfile $PIDFILE \
        --background \
        --exec $DAEMON -- $DAEMON_ARGS \
        || return 2

}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

case "$1" in
  start)
    [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
    do_start
    case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
  ;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

:
